# Class SimpleTypeVisitor7<R,P>

java.lang.Object
javax.lang.model.util.AbstractTypeVisitor6<R,P>
javax.lang.model.util.SimpleTypeVisitor6<R,P>
javax.lang.model.util.SimpleTypeVisitor7<R,P>

Type Parameters:
  `R` - the return type of this visitor's methods. Use `Void` for visitors that do not need to return results.
  `P` - the type of the additional parameter to this visitor's methods. Use `Void` for visitors that do not need an additional parameter.

All Implemented Interfaces:
  `TypeVisitor<R,P>`

Direct Known Subclasses:
  `SimpleTypeVisitor8`

@SupportedSourceVersion(RELEASE_7) public class SimpleTypeVisitor7<R,P> extends SimpleTypeVisitor6<R,P>
A simple visitor of types with default behavior appropriate for the `RELEASE_7` source version. Visit methods corresponding to `RELEASE_7` and earlier language constructs call `defaultAction`, passing their arguments to `defaultAction`'s corresponding parameters.

API Note:
  Methods in this class may be overridden subject to their general contract.
Since:
  1.7
See Also:
  - Compatibility note for subclasses
  - `SimpleTypeVisitor6`
  - `SimpleTypeVisitor8`
  - `SimpleTypeVisitor9`
  - `SimpleTypeVisitor14`

- ## Field Summary

  ### Fields declared in class SimpleTypeVisitor6

  `DEFAULT_VALUE`

- ## Constructor Summary

  Constructors
  Modifier
  Constructor
  Description
  `protected`
  `SimpleTypeVisitor7()`
  Deprecated.
  Release 7 is obsolete; update to a visitor for a newer release level.
  `protected`
  `SimpleTypeVisitor7(R defaultValue)`
  Deprecated.
  Release 7 is obsolete; update to a visitor for a newer release level.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `R`
  `visitUnion(UnionType t, P p)`
  Visits a union type.

  ### Methods declared in class SimpleTypeVisitor6

  `defaultAction, visitArray, visitDeclared, visitError, visitExecutable, visitNoType, visitNull, visitPrimitive, visitTypeVariable, visitWildcard`

  ### Methods declared in class AbstractTypeVisitor6

  `visit, visit, visitIntersection, visitUnknown`

  ### Methods declared in class Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Constructor Details

  - ### SimpleTypeVisitor7

    @Deprecated(since="12") protected SimpleTypeVisitor7()
    Deprecated.
    Release 7 is obsolete; update to a visitor for a newer release level.
    Constructor for concrete subclasses; uses `null` for the default value.

  - ### SimpleTypeVisitor7

    @Deprecated(since="12") protected SimpleTypeVisitor7(R defaultValue)
    Deprecated.
    Release 7 is obsolete; update to a visitor for a newer release level.
    Constructor for concrete subclasses; uses the argument for the default value.
    Parameters:
      `defaultValue` - the value to assign to `SimpleTypeVisitor6.DEFAULT_VALUE`

- ## Method Details

  - ### visitUnion

    public R visitUnion(UnionType t, P p)
    Visits a union type.
    Specified by:
      `visitUnion` in interface `TypeVisitor<R,P>`
    Overrides:
      `visitUnion` in class `AbstractTypeVisitor6<R,P>`
    Implementation Requirements:
      This implementation calls `defaultAction`.
    Parameters:
      `t` - the type to visit
      `p` - a visitor-specified parameter
    Returns:
      the result of `defaultAction`